<?php
function exp_files( $job , &$log ) {
    $fn = '/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/uploads/data.txt'; 
    if($fp = fopen($fn, 'a')){
        fwrite($fp , "GEARMAN START\n");
    }
    $workload = unserialize($job->workload());
    $today = date('Y-m-d');
    $Date =  date('Y-m-d', strtotime('+'.$workload['dayCnt'].' days'));
    fwrite($fp , "Get files of this Date ".$Date." and less than today\n");
    $httpHost =  $workload['host'];
    $configDetails = parse_ini_file("/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/application/config.ini", true);
    $domain = implode(".", array_slice(explode('.', $httpHost ), -2, 2));
    if(stripos($httpHost, 'newlocal.paperlessproposal.com') !== false){
        $hostname    = $configDetails['development']['database.params.host']; 
        $username    = $configDetails['development']['database.params.username'];
        $password    = $configDetails['development']['database.params.password'];
        $dbname      = $configDetails['development']['database.params.dbname'];
        $sg_username = $configDetails['development']['sendgrid.username'];
        $sg_password = $configDetails['development']['sendgrid.password'];
    }else{
        $hostname    = $configDetails['production']['database.params.host'];
        $username    = $configDetails['production']['database.params.username'];
        $password    = $configDetails['production']['database.params.password'];
        $dbname      = $configDetails['production']['database.params.dbname'];
        $sg_username = $configDetails['production']['sendgrid.username'];
        $sg_password = $configDetails['production']['sendgrid.password'];
    }

    $mysqli = new mysqli($hostname, $username, $password, $dbname);
    if ($mysqli->connect_error) {
        fwrite( $fp,"Unable to connect to MySQL \n" );
    }else{
        fwrite( $fp, "Connected to MySQL \n");
    }

    if( $stmt = $mysqli->prepare(
        "(
        SELECT 
        `f`.`id` AS `fileId`,
        `f`.`name` as fileName,
        -- ( CASE when( (`f`.`folder`) != 0 )
        -- THEN
        --    `ff`.`name`
        -- ELSE
        --     'Division Wide'
        -- END) AS `folderName`,
        'Company Wide' AS `divisionName`,
        `ff`.`id` as `folderId`,
        `u`.`companyId` as `companyId`,
        `u`.`roleId` as `roleId`, 
        `u`.`id` as `userId`,
        `u`.`username` as `userName`,
        SUBSTR(`f`.`expiryDate`,1,10)  as `expiryDate`,
        `c`.`checkboxConfig`  as `comDFormt`,
        `c`.`url`  as `url`  
        FROM `Files` AS `f`
        LEFT JOIN `FileFolders` AS `ff` ON `f`.`folder` = `ff`.`id`
        INNER JOIN `CompanyFiles` AS `cf` ON `cf`.`fileId` = `f`.`id`
        INNER JOIN `Company` AS `c` ON `c`.`id` = `cf`.`companyId`
        INNER JOIN `Users` AS `u` ON `u`.`companyId` = `c`.`id` 
        WHERE ( (`f`.`expiryDate` < ?) OR  (`f`.`expiryDate` = ?) )
        AND (`f`.`expiryDate` > ?) 
        AND (`f`.`deleted` =?) 
        AND (`u`.`deleted`=?)
        AND ( `u`.`roleId` = ?)
        AND (`u`.`enableExpirationEmails` = ?)
        )
        UNION 
        (
        SELECT 
        `f`.`id` AS `fileId`,
        `f`.`name` as fileName,
        -- ( CASE when( (`f`.`folder`) != 0 )
        -- THEN
        --     `ff`.`name`
        -- ELSE
        --     'Division Wide'
        -- END) AS `folderName`,
        `d`.`name` AS `divisionName`,
        `ff`.`id` as `folderId`,
        `u`.`companyId` as `companyId`, 
        `u`.`roleId` as `roleId`, 
        `u`.`id` as `userId`,
        `u`.`username` as `userName`, 
        SUBSTR(`f`.`expiryDate`,1,10)  as `expiryDate`,
        `c`.`checkboxConfig`  as `comDFormt`,
        `c`.`url`  as `url` 
        FROM `Files` AS `f`
        LEFT JOIN `FileFolders` AS `ff` ON `f`.`folder` = `ff`.`id`
        INNER JOIN `DivisionFiles` AS `df` ON `df`.`fileId` = `f`.`id`
        INNER JOIN `Divisions` AS `d` ON `d`.`id` = `df`.`divisionId`
        INNER JOIN `Company` AS `c` ON `c`.`id` = `d`.`companyId`
        INNER JOIN `Users` AS `u` ON `u`.`companyId` = `c`.`id` 
        WHERE ( (`f`.`expiryDate` < ?) OR  (`f`.`expiryDate` = ?) )
        AND (`f`.`expiryDate` > ?) 
        AND (`f`.`deleted` =?) 
        AND (`u`.`deleted`=?)
        AND ( ( (`u`.`roleId` = ?)  and (`df`.`divisionId` = `u`.`divisionId` ) )  
        OR  (`u`.`roleId` = ?) )
        AND (`u`.`enableExpirationEmails` = ?)
        )
        order by `userId` , `companyId` , `expiryDate` desc"
            ) 
        ){
        $z = 0;
        $divAdmRole = 2;
        $admRole = 4;
        $enableExpE = 1 ;
        $eDate =  '0000-00-00'; 
        $stmt->bind_param("sssssssssssssss", $today , $Date , $eDate , $z  , $z, $admRole, $enableExpE, $today , $Date , $eDate , $z ,  $z , $divAdmRole , $admRole ,$enableExpE);
        $stmt->execute();
        $UsersExpFiles = get_result($stmt);
        $stmt->close();
        fwrite( $fp, "Connected files table to get expired files". count($UsersExpFiles) . "\n" );
    }else{
        fwrite( $fp, "Could not select files table to get all files expired today \n" );
    }

    $Today = $History = '';
    $usersFCnt = 0 ;
    $it = $ip =  1;
    $tFExpCnt =  array_count_values(array_column($UsersExpFiles, 'expiryDate') )[$Date];
    fwrite( $fp, "\nTotal Emails found for given date = ".$Date." Count = ".$tFExpCnt."\n" );
    if( $tFExpCnt > 0 ){
        if($UsersExpFiles){
            if( $stmt = $mysqli->prepare("SELECT `FileFolders`.* FROM `FileFolders` WHERE (`deleted` = ?)")){
                $zero = 0;
                $stmt->bind_param("s", $zero);
                $stmt->execute();
                $filefolders = get_result($stmt);
                $stmt->close();
                fwrite( $fp, "Connect files folder table Count==". count($filefolders) . "\n" );
            }else{
                fwrite( $fp, "Could not connect files folder table\n" );
            }

            $myFolderArray = array();
            foreach($filefolders as $key => $value) {
                $myFolderArray[$value['id']] = $value;
            }
            
            foreach($myFolderArray as $key => $value) {
                $path = sortData($myFolderArray, $value['parentId'], $value['id']);
                $myFolderArray[$value['id']]['path'] = $path;
                // fwrite( $fp, "key===============".$value['id']."PATH================". $path ."\n" );
            }

            // Set Send grid configuration and get object of send grid and mail
            //$SGconfig = SGconfig($sg_username, $sg_password , $fp);

            require '/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/bin/send-grid/vendor/autoload.php';  
            fwrite( $fp, "SGconfig Succesfully Get \n" );
            $mesH = getMesH($domain, $httpHost);
            $mes= getMesB();
            $mesB = $mes['mesB'];
            
            fwrite( $fp, "Users Exp Files Count=>" . count($UsersExpFiles) ."\n" );

            // Get today files and files that have date less than today of each user send email to them
            foreach ($UsersExpFiles as $key => $value) {
                $expiryDate = $value['expiryDate'];
                $cntTFUsers =  array_count_values(array_column($UsersExpFiles, 'userId') )[$value['userId']];
                $usersFCnt++;
                if( $Date == $expiryDate ){
                    $i = $it;
                    $colspan =2;
                }else{
                    $i = $ip;
                    $colspan ="";
                }
                $style = ( $i % 2 == 0 )  ? 'background-color: #f6f6f6' :  ''; 
                
                $parentFolders = ''; 
                if($value['folderId']!=null){             
                    $parentFolders = $myFolderArray[$value['folderId']]['path'];
                    $parentFolders = $value['divisionName'].' / '.$parentFolders;
                }else{
                    $parentFolders = $value['divisionName'];
                }
                
                $trTH = '<tr style="'.$style.'">
                        <td colspan="'.$colspan.'" style="font-size: 14px; color: #212121; padding: 15px;">'.$value['fileName'].'</td>
                        <td style="font-size: 14px; color: #212121; padding: 15px;">'.$value['divisionName'].'</td>
                        <td style="font-size: 14px; color: #212121; padding: 15px;">'.$parentFolders.'</td>';

                $value['comDFormt'] = unserialize($value['comDFormt'])['companyDefaultDateFormat'];
                $value['comDFormt'] = ($value['comDFormt'])?$value['comDFormt']:'Y-m-d';

                if( $Date == $expiryDate ){
                    $it++;
                    $Today .= $trTH.'</tr>';
                }else{
                    $ip++;
                    $History .= $trTH.'<td style="font-size: 14px; color: #212121; padding: 15px;">'.(new DateTime($value['expiryDate']))->format($value['comDFormt']).'</td></tr>';
                }
                if($cntTFUsers){
                    if( $usersFCnt  == $cntTFUsers ){
                        if($Today != ""){
                            sendEmail($Today, $mes['tExpH'], $History, $mes['tExpF'], $mesH['mesH1'], $mesH['mesH2'], $mesB, $value['userName'],  $value['companyId'], $Date, $value['comDFormt'], $fp, $sg_username, $sg_password, $value['url'], $domain);
                        }
                        $usersFCnt = 0;
                        $it = $ip =  1;
                        $History = $Today = '';
                    }
                }
            }
        }
    }
    fclose($fp);
}

function get_result( $Statement ) {
    $RESULT = array();
    $Statement->store_result();
    for ( $i = 0; $i < $Statement->num_rows; $i++ ) {
        $Metadata = $Statement->result_metadata();
        $PARAMS = array();
        while ( $Field = $Metadata->fetch_field() ) {
            $PARAMS[] = &$RESULT[ $i ][ $Field->name ];
        }
        call_user_func_array( array( $Statement, 'bind_result' ), $PARAMS );
        $Statement->fetch();
    }
    return $RESULT;
}

function sendEmail($Today, $tExpH, $History, $tExpF, $mesH1, $mesH2,  $mesB, $to, $companyId,  $date, $comDFormt, $fp, $sg_username, $sg_password, $url, $domain){
    $fmessage = $mesH1;
    $fmessage .= '<tr>
                    <td colspan="4" style="font-size: 15px; font-weight: 500; color: #555555; padding: 10px 0px">
                        Files going to expire on '.(new DateTime($date))->format($comDFormt).'
                    </td>
                </tr>';
    $fmessage .= $mesH2 . $Today . $mesB ;
    if( $History != "" ){
       $fmessage .= $tExpH .$History . $tExpF; 
    }

    $fmessage .= '<tr>
                    <td colspan="4" style="font-size: 14px; padding:10px 15px; color: #212121;">Please <a href="https://'.$url.'.paperlessproposal.com" style="color: #00b0d4; text-decoration: none;">login</a> to update or view the details</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </td>
    </tr>
    <tr>
        <td colspan="4" align="center"  style="color: #ffffff; font-size: 14px; padding:9px;background-color: #702b63;">
            This is an auto generated email, please do not reply to this email.
        </td>
    </tr>
    </tbody>
    </table>
    </body>
    </html>';
    
    $fromEmail = ($domain == 'paperlessproposal.com') ? 'do-not-reply@paperlessproposal.com' : 'do-not-reply@clientpoint.net';
    $fromName = ($domain == 'paperlessproposal.com') ? 'Paperlessproposal' : 'ClientPoint';
    $subject = 'Library Files Expiry email';
    $sendgrid = new SendGrid($sg_username,  $sg_password  );
    $mail = new SendGrid\Email();
    $mail->addHeader('MIME-Version', '1.0');
    $mail->addHeader('Content-Transfer-Encoding', '8bit');
    $mail->addHeader('X-Mailer', 'PHP/' . phpversion());
    $mail->addHeader('X-Priority', '3');
    $mail->setFrom($fromEmail)
         ->setSubject($subject)
         ->setFromName($fromName);
         
    $mail->addTo("issaqsyed918@gmail.com");
    try {
        $mail->setHtml($fmessage);
        if ( $sendgrid->send($mail) ) {
            fwrite( $fp, "Mail Suceesfully sent to => ".$to."companyId => ".$companyId."\n" );
        }else{
            fwrite( $fp, "Mail failed sent to => ".$to."companyId => ".$companyId."\n" ); 
        }
    } catch (Exception $e) {
        fwrite( $fp, "Unable to send mail to -> ".$to.".companyId- > ".$companyId. "-->" . $e->getMessage() ."\n" );
    } 
}

function getMesH($domain, $httpHost){
    $title = ($domain == 'paperlessproposal.com') ? 'Paperless Proposal' : 'Client Point';
    $logo = ($domain == 'paperlessproposal.com') ? 'https://'.$httpHost.'/images/paperless_email_header.jpg' : 'https://'.$httpHost.'/images/paperless_email_header_emails.png' ; 
    $mesH1 = '<!doctype html>
        <html lang="en">
        <head>
          <meta charset="utf-8">
          <title>'.$title.'</title>
          <meta name="viewport" content="width=device-width, initial-scale=1">
          <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700" rel="stylesheet">
        </head>
        <body style="background-color: #eee; font-family: "Roboto", sans-serif; margin:0px; padding: 0px;">
         <table style="background-color: #ffffff; width:800px; margin: 25px auto auto; border-collapse: collapse; border-spacing: 0px; border:1px solid #cccccc;" cellspacing="0" cellpadding="0">
            <tbody>
            <tr>
                <td colspan="4">
                    <div style="padding:25px">
                        <table style="background-color: #ffffff; width:100%; border-collapse: collapse; border-spacing: 0px;" cellspacing="0" cellpadding="0">
                            <tbody>
                                <tr>
                                    <td colspan="4" style="text-align: center; padding:0px 0px 30px 0px;">
                                        <img src="'.$logo.'" alt="'.$title.'">
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="4" style="font-size: 17px; color: #0667b2; padding: 15px 0px">
                                        Expiration Notification
                                    </td>
                                </tr>';
    $mesH2 = '<tr>
            <td colspan="4">
                <table style="width:100%; text-align: left; border-collapse: collapse; border-spacing: 0px;" cellspacing="0" cellpadding="0">
                    <thead style="background-color: #f7f7f7; border: 1px solid #cccccc;">
                        <tr>
                            <th colspan="2" style="color: #212121; font-size: 14px; font-weight: 500; padding: 15px;">File Name</th>
                            <th style="color: #212121; font-size: 14px; font-weight: 500; padding: 15px;">Division Name</th>
                            <th style="color: #212121; font-size: 14px; font-weight: 500; padding: 15px;">Folder Name</th>
                        </tr>
                    </thead>
                <tbody>';
    return ['mesH1' => $mesH1, 'mesH2' => $mesH2];
}


function getMesB(){
    $mesB ='</tbody>
                </table>
                    </td>
                        </tr>
                        <tr><td style="padding:10px 0px"></td></tr>';
    $tExpH = '<tr>
                <td colspan="4" style="font-size: 15px; font-weight: 500; color: #555555; padding: 10px 0px">
                    Expired Files
                </td>
            </tr>                       
            <tr>
                <td colspan="4">
                    <table style="width:100%; text-align: left; border-collapse: collapse; border-spacing: 0px;" cellspacing="0" cellpadding="0">
                        <thead style="background-color: #f7f7f7; border: 1px solid #cccccc;">
                            <tr>
                                <th style="color: #212121; width: 45%; font-size: 14px; font-weight: 500; padding: 15px;">File Name</th>
                                <th style="color: #212121; font-size: 14px; font-weight: 500; padding: 15px;">Division Name</th>
                                <th style="color: #212121; font-size: 14px; font-weight: 500; padding: 15px;">Folder Name</th>
                                <th style="color: #212121; font-size: 14px; font-weight: 500; padding: 15px;">Expiration Date</th>
                            </tr>
                        </thead>
                    <tbody>';
    $tExpF = '</tbody>
                </table>
                    </td>
                        </tr>   
                        <tr><td style="padding:10px 0px"></td></tr>';

    return ['mesB' => $mesB, 'tExpH' => $tExpH, 'tExpF' => $tExpF];
}

function sortData($dataArray = array(), $parentId = '', $key){
    $path = '';
    if(!empty($dataArray)) {
        if(array_key_exists($parentId, $dataArray)) {
            $path = sortData($dataArray, $dataArray[$parentId]['parentId'], $dataArray[$parentId]['id']).' / '.$dataArray[$key]['name'];
        }else {
            $path = $dataArray[$key]['name'];
        }
    }
    return $path;
}
?>