<?php
function overlay($job, &$log) {

    $workload = unserialize($job->workload());
        
    $headerFile = $workload['headerFile']; 
    $footerFile = $workload['footerFile']; 
    $replacements = $workload['replacements']; 
    $startPage = $workload['startPage']; 
    $totalPages = $workload['totalPages']; 
    $blankFile = $workload['blankFile']; 
    $stampFile = $workload['stampFile'];
    $convertInput = $workload['convertInput']; 
    $outputPath = $workload['outputPath']; 
    $dimensions = $workload['dimensions']; 
    $marginTop = empty($workload['marginTop']) ? 10 : $workload['marginTop'];
    $marginBottom = empty( $workload['marginBottom'] ) ? 9 : $workload['marginBottom']; 
    $marginLeft = $workload['marginLeft']; 
    $marginRight = $workload['marginRight']; 
    //echo "HEADER FILE " . $headerFile;    
    if( empty($marginBottom) ){
		$marginBottom = 9;
	}
	
	if( empty($marginTop) ){
		$marginTop = 10;
	}

    if($marginLeft != '')
    {
        $marginLeft = number_format($marginLeft, 1, '.', '');
    }

    if($marginRight != '')
    {
        $marginRight = number_format($marginRight, 1, '.', '');
    }

    $fp = fopen('/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/uploads/data.txt', 'a');
    $msg = "\n Gearman Overlay for stamp --- $stampFile \n";
 

    $portrait = true;
    $finalSize = "";
    if( $dimensions['width'] > $dimensions['height']){
        $portrait = false;
        if( $dimensions['width'] > 720 ){
            $height = "--page-height ".$dimensions['width']."pt";
            $width = "--page-width ".$dimensions['height']."pt";
            $finalSize = $height." ".$width." ";  
        }
    }
    
    if( $dimensions['rotation'] == '90' || $dimensions['rotation'] == '270' ){
        $portrait = !$portrait;
        if( $dimensions['width'] > 720 ){
            $finalSize = "";
        }
    }
    
    $orientation = $portrait ? 'Portrait' : 'Landscape';
    
    $command = "/usr/local/bin/wkhtmltopdf-amd64 --load-error-handling ignore -s Letter ".$finalSize."--orientation $orientation --no-background --margin-bottom $marginBottom --margin-top $marginTop ".($marginLeft == ''? '': '--margin-left '.$marginLeft.'mm')." ".($marginRight == ''? '': '--margin-right '.$marginRight.'mm')." --header-html $headerFile  --footer-html $footerFile $replacements --replace startpage $startPage --replace totalpages $totalPages $blankFile $stampFile";

    $msg .= "\n == wkhtmltopdf Command == \n $command \n";
    


    //exec( "/usr/local/bin/wkhtmltopdf-amd64 -s Letter --no-background --margin-bottom 9 --header-html $headerFile  --footer-html $footerFile $replacements --replace startpage $startPage --replace totalpages $totalPages $blankFile $stampFile" );
    exec( "/usr/local/bin/wkhtmltopdf-amd64 --load-error-handling ignore -s Letter ".$finalSize."--orientation $orientation --no-background --margin-bottom $marginBottom --margin-top $marginTop ".($marginLeft == ''? '': '--margin-left '.$marginLeft.'mm')." ".($marginRight == ''? '': '--margin-right '.$marginRight.'mm')." --header-html $headerFile  --footer-html $footerFile $replacements --replace startpage $startPage --replace totalpages $totalPages $blankFile $stampFile", $output, $return_var);
    // do the overlay/stamp and store pdf and images in the proposal directory identified by proposalFileId
    
    $msg .= "\n WKHTMLTOPDF Response \n ".print_r($output, true)." \n Return variable \n $return_var \n";

    if (file_exists($stampFile))
    {
        $msg .= "\n == Stamp Generated == \n".$stampFile."\n";

        $pdftkcommand = "pdftk $convertInput multistamp $stampFile output $outputPath";
        $msg .= "\n == pdftk command == \n".$pdftkcommand. "\n";

        $pdfTkresponse = exec( "pdftk $convertInput multistamp $stampFile output $outputPath", $outputpdfTk, $return_varpdfTk);
        chmod($outputPath, 0666);    


        $msg .= "\n PDFTK Response \n ".print_r($outputpdfTk, true)." \n Return variable \n $return_varpdfTk \n";
        
        $log[] = "Success";
        $msg .= "\n == Success == \n";
    
    }
    else{
        $msg .= "\n == Failed == \n";
    }

    fwrite($fp, $msg);
    fclose($fp);

    $job->sendComplete("Success");
    return 'Success';
    
    

}
?>

