<?php
function pdf_to_jpg($job, &$log) {

    $workload = unserialize($job->workload());
    if(!isset($workload['conversionType']))
    {
		$workload['conversionType'] = 0;	
	}
	
	if($workload['conversionType'] == 1)
    {		
		// Generate images and json for flowpaper
		$proposalId 	= $workload["proposalId"];
		$proposalfileid = $workload["proposalfileid"];
		$fileid 		= $workload["fileid"];
		$istemplate 	= $workload["istemplate"];
		$isOverlayed 	= $workload["isOverlayed"];
		$isCad 			= $workload["isCad"];	
		$skipFileCompression 			= $workload["skipFileCompression"];	

		$proposalPath = $workload["proposalPath"];
		$includePath = $workload["includePath"];
		$companyId = $workload["companyId"];

		if($isOverlayed == 1)
		{
			$doc=$proposalfileid."_overlaid.pdf";
			$pdfPath 	= "$proposalPath/proposal_$proposalId/";
			$pdfFilePath 	= "$proposalPath/proposal_$proposalId/".$proposalfileid."_overlaid.pdf";
		}
		elseif($istemplate==1)
		 {
			$doc=$proposalfileid.".pdf";
			$pdfPath 	= "$proposalPath/proposal_$proposalId/";
			$pdfFilePath 	= "$proposalPath/proposal_$proposalId/$proposalfileid.pdf";
		 }
		 else if($istemplate==0)
		 {
			$doc=$fileid.".pdf";
			$pdfPath 	= "$includePath/company_$companyId/";
			$pdfFilePath 	= "$includePath/company_$companyId/$fileid.pdf";
		 }	
		$output=array();
		$pdfoutputPath 	= "$proposalPath/proposal_$proposalId/flexviewer/";
		$mobilePdfoutputPath 	= "$proposalPath/proposal_$proposalId/flexviewer/mobile/";
		$jsonWithSplitPath = $pdfoutputPath.$doc."_%.js";		
		$jsonWithSplitPathToCheck = $pdfoutputPath.$doc."_10.js";		
		$jsonWithoutSplitPath = $pdfoutputPath.$doc.".js";		
		$jsonWithSplitCommand = "pdf2json $pdfFilePath -enc UTF-8 -compress -split 10 $jsonWithSplitPath";
		$jsonWithoutSplitCommand = "pdf2json $pdfFilePath -enc UTF-8 -compress $jsonWithoutSplitPath";				
		$return_var=0;
		$start = 1;
		$limit = 10;
		$generateImgs = 1;
		while(1){
				if(file_exists($pdfFilePath)){
					
					if(file_exists($jsonWithSplitPathToCheck)){
						// check if pdf modified time is greater than json
						if(filectime($pdfFilePath) > filectime($jsonWithSplitPathToCheck))
						{							
							$delpngFilesGenerated = glob($pdfoutputPath.$doc."_*.png");
							$deljpgFilesGenerated = glob($pdfoutputPath.$doc."_*.jpg");
							$deljsonFilesGenerated = glob($pdfoutputPath.$doc."_*.js");							
							if(isset($delpngFilesGenerated) && count($delpngFilesGenerated) > 0){
								foreach ($delpngFilesGenerated as $viewerPngFileName) {								
									unlink($viewerPngFileName);								
								}
							}
							if(isset($deljpgFilesGenerated) && count($deljpgFilesGenerated) > 0){
								foreach ($deljpgFilesGenerated as $viewerJpgFileName) {								
									unlink($viewerJpgFileName);								
								}
							}
							if(isset($deljsonFilesGenerated) && count($deljsonFilesGenerated) > 0){
								foreach ($deljsonFilesGenerated as $viewerJsFileName) {																
									unlink($viewerJsFileName);								
								}
							}
							if(file_exists($jsonWithoutSplitPath)){																							
									unlink($jsonWithoutSplitPath);
							}							
							$generateImgs = 1;
						}
						else
						{
							$generateImgs = 0;
						}
					}
						
					if($generateImgs==1)
					{
						// create json with split mode from pdf
						exec($jsonWithSplitCommand,$output,$return_var);
						// create json without split mode from pdf
						exec($jsonWithoutSplitCommand,$output,$return_var);

						$docImagesPathFull = $pdfoutputPath.$doc."_%d.png";
						$docMobileImagesPathFull = $mobilePdfoutputPath.$doc."_%d.png";
						$return_var=0;
						if($isCad==1)
						{
							$pngCommand="convert -density 155 -scene 1 pdf:$pdfFilePath -colorspace RGB +level 0%,100%,0.7 -alpha remove $docImagesPathFull";		
							exec($pngCommand);		
						}else{
							$pngCommand="mudraw -r250 -o $docImagesPathFull $pdfFilePath";
							exec($pngCommand,$output,$return_var);
						}
							
						if($return_var==1 || $return_var==0 || (strstr(PHP_OS, "WIN") && $return_var==1)){
							// Generate jpg images from png start
							$pngFilesGenerated = glob($pdfoutputPath.$doc."_*.png");
							if(!empty($pngFilesGenerated))
							{
								foreach($pngFilesGenerated as $pngFile)
								{
									$fileNameArray  = explode('.png',end(explode('/',$pngFile)));									
									if(($isCad == 1) || ($skipFileCompression == 1)){
										$output_jpg_file         = $pdfoutputPath.$fileNameArray[0]."_hdres_.jpg";							
									}
									else
									{
										$output_jpg_file         = $pdfoutputPath.$fileNameArray[0]."_res_.jpg";																
									}					
									$src = @ImageCreateFromPng($pngFile); // original image
									$jpg_quality = 75;
									$dimensions   = GetImageSize($pngFile);
									$width        = $dimensions[0];
									$height       = $dimensions[1];
									$ratio      	= $height/$width;							
									// We need to resize the source image to the width of the resolution breakpoint we're working with							
									if(($isCad == 1) || ($skipFileCompression == 1)){
										$new_width  = $width;
										$new_height = $height;
									}else{
										$new_width  = 1200;
										$new_height = ceil($new_width * $ratio);
									}
									
									$dst        = ImageCreateTrueColor($new_width, $new_height); // re-sized image
									imagealphablending($dst, false);
									imagesavealpha($dst,true);
									$transparent = imagecolorallocatealpha($dst, 255, 255, 255, 127);
									imagefilledrectangle($dst, 0, 0, $new_width, $new_height, $transparent);
									ImageCopyResampled($dst, $src, 0, 0, 0, 0, $new_width, $new_height, $width, $height); // do the resize in memory
									ImageDestroy($src);

									$gotSaved = ImageJpeg($dst, $output_jpg_file, $jpg_quality);
									ImageDestroy($dst);
								}
							}					
							// Generate jpg images from png end                
						}
					}
					//error_log('ATTEMPT -> '.$start);
					break;
				}
				if($start > $limit){
					break;
				}
				$start++;
				sleep(5);
			}
		
	}
	else
	{		
		// Generate images for normal preview
		$inputFile = $workload['inputFile'];
		$outputFile = $workload['outputFile'];
		$outputPath = $workload['outputPath'];
		$fileNameBase = $workload['fileNameBase'];
		// generate a random string so that in the rename process we do not overwrite images in case two of these are happening to the same file at once.
		$bytes = openssl_random_pseudo_bytes(4);
		$random   = bin2hex($bytes);
		
		// add .gs onto the end so that these images do not get served until they are done being generated and renamed appropriately
		$outputFile = $outputFile . ".$random.png";

		// do work on $job here as documented in pecl/gearman docs

		// Log is an array that is passed in by reference that can be
		// added to for logging data that is not part of the return data
		
		$start = 1;
			$limit = 10;
			while(1){
					if(file_exists($inputFile)){
			// return your result for the client
					 $result = exec("gs -q -dQUIET -dSAFER -dBATCH -dNOPAUSE -dNOPROMPT -dMaxBitmap=500000000 -dAlignToPixels=0 -dGridFitTT=2 -sDEVICE=png16m -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -r700 -dUseCropBox -sOutputFile=$outputFile -dDownScaleFactor=4 $inputFile");
		
					 $i = 1;
					 $f = 0;
		//while( rename( $outputPath . $fileNameBase . "-$i.jpg", $outputPath . $fileNameBase . "-" . $i-1 . ".jpg") ){
				  while( rename($outputPath . $fileNameBase . "-" . $i . ".jpg.$random.png", $outputPath . $fileNameBase . "-" . $f . ".jpg.$random.png") ){
				  exec( "convert " . $outputPath . $fileNameBase . "-" . $f . ".jpg.$random.png " . $outputPath . $fileNameBase . "-" . $f . ".jpg"  );
				  chmod($outputPath . $fileNameBase . "-" . $f . ".jpg.$random.png", 0666);
				  chmod($outputPath . $fileNameBase . "-" . $f . ".jpg", 0666);
				  $i++;
					$f++;
				  }
			 break;
			  }
			 if($start > $limit){
				  break;
				 }
		  $start++;
		  sleep(5);
		  }
		
		$log[] = "Success";
		return $result;
    
	}

}
?>

